Package org.apache.catalina.valves

## Class HealthCheckValve

- java.lang.Object
- - org.apache.catalina.util.LifecycleBase
  - - org.apache.catalina.util.LifecycleMBeanBase
    - - org.apache.catalina.valves.ValveBase
      - - org.apache.catalina.valves.HealthCheckValve

All Implemented Interfaces:
  `MBeanRegistration`, `Contained`, `JmxEnabled`, `Lifecycle`, `Valve`

    public class HealthCheckValve
    extends ValveBase

Simple Valve that responds to cloud orchestrators health checks.

### Nested Class Summary

### Nested classes/interfaces inherited from interface org.apache.catalina.Lifecycle

`Lifecycle.SingleUse`

### Field Summary

Fields
`protected boolean` `checkContainersAvailable` Check if all child containers are available.
`protected boolean` `context` Will be set to true if the valve is associated with a context.

### Fields inherited from class org.apache.catalina.valves.ValveBase

`asyncSupported, container, containerLog, next, sm`

### Fields inherited from interface org.apache.catalina.Lifecycle

`AFTER_DESTROY_EVENT, AFTER_INIT_EVENT, AFTER_START_EVENT, AFTER_STOP_EVENT, BEFORE_DESTROY_EVENT, BEFORE_INIT_EVENT, BEFORE_START_EVENT, BEFORE_STOP_EVENT, CONFIGURE_START_EVENT, CONFIGURE_STOP_EVENT, PERIODIC_EVENT, START_EVENT, STOP_EVENT`

### Constructor Summary

Constructors
`HealthCheckValve()`

### Method Summary

All Methods Instance Methods Concrete Methods
`boolean` `getCheckContainersAvailable()`
`String` `getPath()`
`void` `invoke​(Request request, Response response)` Perform request processing as required by this Valve.
`protected boolean` `isAvailable​(Container container)`
`void` `setCheckContainersAvailable​(boolean checkContainersAvailable)`
`void` `setPath​(String path)`
`protected void` `startInternal()` Start this component and implement the requirements of `LifecycleBase.startInternal()`.

### Methods inherited from class org.apache.catalina.valves.ValveBase

`backgroundProcess, getContainer, getDomainInternal, getNext, getObjectNameKeyProperties, initInternal, isAsyncSupported, setAsyncSupported, setContainer, setNext, stopInternal, toString`

### Methods inherited from class org.apache.catalina.util.LifecycleMBeanBase

`destroyInternal, getDomain, getObjectName, postDeregister, postRegister, preDeregister, preRegister, register, setDomain, unregister, unregister`

### Methods inherited from class org.apache.catalina.util.LifecycleBase

`addLifecycleListener, destroy, findLifecycleListeners, fireLifecycleEvent, getState, getStateName, getThrowOnFailure, init, removeLifecycleListener, setState, setState, setThrowOnFailure, start, stop`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### context

    protected boolean context

Will be set to true if the valve is associated with a context.

#### checkContainersAvailable

    protected boolean checkContainersAvailable

Check if all child containers are available.

### Constructor Detail

#### HealthCheckValve

    public HealthCheckValve()

### Method Detail

#### getPath

    public final String getPath()

#### setPath

    public final void setPath​(String path)

#### getCheckContainersAvailable

    public boolean getCheckContainersAvailable()

#### setCheckContainersAvailable

    public void setCheckContainersAvailable​(boolean checkContainersAvailable)

#### startInternal

    protected void startInternal()
                          throws LifecycleException

Description copied from class: `ValveBase`
Start this component and implement the requirements of `LifecycleBase.startInternal()`.

Overrides:
  `startInternal` in class `ValveBase`
Throws:
  `LifecycleException` - if this component detects a fatal error that prevents this component from being used

#### invoke

    public void invoke​(Request request,
                       Response response)
                throws IOException,
                       ServletException

Description copied from interface: `Valve`

Perform request processing as required by this Valve.

An individual Valve MAY perform the following actions, in the specified order:

- Examine and/or modify the properties of the specified Request and Response.
- Examine the properties of the specified Request, completely generate the corresponding Response, and return control to the caller.
- Examine the properties of the specified Request and Response, wrap either or both of these objects to supplement their functionality, and pass them on.
- If the corresponding Response was not generated (and control was not returned, call the next Valve in the pipeline (if there is one) by executing `getNext().invoke()`.
- Examine, but not modify, the properties of the resulting Response (which was created by a subsequently invoked Valve or Container).

A Valve MUST NOT do any of the following things:

- Change request properties that have already been used to direct the flow of processing control for this request (for instance, trying to change the virtual host to which a Request should be sent from a pipeline attached to a Host or Context in the standard implementation).
- Create a completed Response AND pass this Request and Response on to the next Valve in the pipeline.
- Consume bytes from the input stream associated with the Request, unless it is completely generating the response, or wrapping the request before passing it on.
- Modify the HTTP headers included with the Response after the `getNext().invoke()` method has returned.
- Perform any actions on the output stream associated with the specified Response after the `getNext().invoke()` method has returned.

Parameters:
  `request` - The servlet request to be processed
  `response` - The servlet response to be created
Throws:
  `IOException` - if an input/output error occurs, or is thrown by a subsequently invoked Valve, Filter, or Servlet
  `ServletException` - if a servlet error occurs, or is thrown by a subsequently invoked Valve, Filter, or Servlet

#### isAvailable

    protected boolean isAvailable​(Container container)